\usepackage{tikz}
\usepackage{ifthen}
\usepackage{printlen}
\usepackage{hyperref}
\usepackage[absolute,overlay]{textpos}
\usepackage{xparse}

\mode<presentation>

%title image and logo
\def\titleimage#1{\def\@titleimage{#1}}
\def\titlelogo#1{\def\@titlelogo{#1}}
\def\titlesource#1{\def\@titlesource{#1}}

\titleimage{bauplan}
\titlelogo{sdq_logo}
\titlesource{}

\setbeamersize{text margin left=6mm,text margin right=6mm}

\newlength{\myPageWidth}
\NewDocumentCommand{\setAspectRatio}{ m O{1}}{
	\pgfmathsetlength\myPageWidth{96mm*#1/#2}
	\geometry{papersize={\myPageWidth,96mm}}
}

%set ratio according to beamer defaults
\pgfmathparse{\paperwidth/\paperheight}
\setAspectRatio{\pgfmathresult}

\newboolean{imageDim}
\setboolean{imageDim}{false}
\newcommand{\showDimension}{\setboolean{imageDim}{true}}
\newboolean{stretchbg}
\setboolean{stretchbg}{false}
\newcommand{\strechBackground}{\setboolean{stretchbg}{true}}
\newboolean{sourcebg}
\setboolean{sourcebg}{true}
\newcommand{\hideSourceBackground}{\setboolean{sourcebg}{false}}
\newcommand{\imageBackground}[1]{\colorlet{bgColor}{#1}}
\newboolean{shownavigation}
\setboolean{shownavigation}{true}
\newcommand{\hideNavigation}{\setboolean{shownavigation}{false}}

\imageBackground{white}
\setbeamertemplate{title page}{
	\thispagestyle{empty}
	
	% title image	
	\begin{textblock*}{\paperwidth-12mm}(6mm,45mm)
		\newlength{\sourceLength}
		\settowidth{\sourceLength}{\textcolor{black}{\tiny\@titlesource}}
		\begin{pgfpicture}{0mm}{0mm}{\paperwidth-12mm}{45mm}%
			{\pgfsetcornersarced{\pgfpoint{2mm}{2mm}}
				\pgfpathmoveto{\pgfpoint{0mm}{45mm}}
				\pgfpathlineto{\pgfpoint{\paperwidth-12mm}{45mm}}}
			\pgfpathlineto{\pgfpoint{\paperwidth-12mm}{0mm}}
			{\pgfsetcornersarced{\pgfpoint{2mm}{2mm}}
				\pgfpathlineto{\pgfpoint{0mm}{0mm}}
				\pgfpathlineto{\pgfpoint{0mm}{5mm}}}
			\pgfpathclose
			\pgfusepath{use as bounding box, clip}
			%\color{bgColor}
			%\pgfusepath{fill}
			
			\pgfpathqmoveto{-1mm}{-1mm}
			\pgfpathlineto{\pgfpoint{\paperwidth-10mm}{-1mm}}
			\pgfpathlineto{\pgfpoint{\paperwidth-10mm}{47mm}}
			\pgfpathlineto{\pgfpoint{-1mm}{47mm}}
			\pgfpathclose
			\color{bgColor}
			\pgfusepath{fill}
			
			\pgftext[at=\pgfpoint{(\paperwidth-12mm)*0.5}{22.5mm}]{%
				\ifthenelse{\boolean{stretchbg}}{%
					\includegraphics[width=\paperwidth-12mm, height=45mm]{\@titleimage}%
				}{%
					\includegraphics[width=\paperwidth-12mm, height=45mm, keepaspectratio]{\@titleimage}%
				}%
			}%
			\ifthenelse{\boolean{sourcebg}}{
				\pgfpathqmoveto{\paperwidth-6mm}{-1mm}
				\pgfpathlineto{\pgfpoint{\paperwidth-6mm}{4mm}}
				
				{\pgfsetcornersarced{\pgfpoint{2mm}{2mm}} 
					\pgfmathsubtract{\paperwidth-14.5mm}{\sourceLength}
					\pgfpathlineto{\pgfpoint{\pgfmathresult}{4mm}}}
				
				\pgfmathsubtract{\paperwidth-14.5mm}{\sourceLength}
				\pgfpathlineto{\pgfpoint{\pgfmathresult}{-1mm}}
				\pgfpathlineto{\pgfpoint{\paperwidth-12mm}{-1mm}}
				\pgfpathclose
				\color{black!15}
				\pgfusepath{fill}
			}{}
			
			\pgftext[right, center, at=\pgfpoint{\paperwidth-13mm}{2mm}]{\textcolor{black}{\tiny\@titlesource}}
			
			\ifthenelse{\boolean{imageDim}}{%
				\color{black}
				\pgftext[at=\pgfpoint{(\paperwidth-12mm)*0.5}{22.5mm}]{%
					\newlength{\myImageWidth}%
					\pgfmathsetlength\myImageWidth{\paperwidth-12mm}%
					\newlength{\myImageHeight}%
					\pgfmathsetlength\myImageHeight{45mm}%
					\uselengthunit{mm}%
					\kitbox{%
						\rndprintlength{\myImageWidth}%
						\,$\times$\,%
						\rndprintlength{\myImageHeight}}%
				}%
			}{}%
		\end{pgfpicture}
	\end{textblock*}
	
	\ifx\@titlesource\empty%
		\hideSourceBackground%
	\fi%
	
	%middle block with name of institute
%	\begin{textblock*}{\paperwidth}(0mm,45mm)
%		\begin{pgfpicture}{0mm}{0mm}{\paperwidth}{6mm}
%			\color{black!50}
%			\pgfpathrectangle{\pgfpoint{0mm}{0mm}}{\pgfpoint{\paperwidth}{6mm}}
%			\pgfusepath{fill}
%			\pgftext[at=\pgfpoint{6mm}{3mm},left,center]{\textcolor{white}{\tiny\uppercase\expandafter{\insertinstitute}}}
%		\end{pgfpicture}
%	\end{textblock*}
	
	\begin{textblock*}{16mm}(\paperwidth-21mm,92mm)
		\fontsize{8pt}{8pt}\selectfont
		\bfseries
		\href{https://www.kit.edu}{www.kit.edu}
	\end{textblock*}
	
	%legal KIT text
	\begin{textblock*}{80mm}[0,1](6mm,96mm)
		\fontsize{4pt}{6pt}\selectfont
		\iflanguage{english}{
			KIT -- The Research University in the Helmholtz Association\\ \ }
		{KIT -- Die Forschungsuniversit{\"a}t in der Helmholtz-Gemeinschaft\\ \ }
	\end{textblock*}
	
	%elements on title page
	
	%KIT logo
	\begin{textblock*}{\paperwidth-12mm}(6mm,5mm)
		\iflanguage{english}{%
			\includegraphics[height=10mm]{logos/kitlogo_en_rgb} 
		}{%
			\includegraphics[height=10mm]{logos/kitlogo_de_rgb} 
		}%
	\end{textblock*}
	
	%institute logo
	\begin{textblock*}{\paperwidth-12mm}(6mm,5mm)
		\hfill\includegraphics[height=10mm]{logos/\@titlelogo} 
	\end{textblock*}
	
	%title
	\begin{textblock*}{\paperwidth-8mm}(6mm,16mm)
		\newlength{\myTitleWidth}%
		\pgfmathsetlength\myTitleWidth{\paperwidth-10mm}%
		\begin{beamercolorbox}[wd=\myTitleWidth,ht=14mm,dp=3mm,left]{white}%
			\Large\textbf{\inserttitle}
		\end{beamercolorbox}
	\end{textblock*}
	
	%subtitle
	\begin{textblock*}{\paperwidth-8mm}(6mm,34mm)
		\scriptsize\bfseries\insertsubtitle
	\end{textblock*}
	
	%author
	\begin{textblock*}{\paperwidth-8mm}(6mm,38mm)
		\scriptsize\bfseries\insertauthor~\textbar~\insertshortdate
	\end{textblock*}
}

%background for pages
\setbeamercolor*{background canvas}{bg=white}
\setbeamercolor*{background}{bg=white}
\pagecolor{white}
%CH: for plain frames
\newlength{\kitbottom}
\usebackgroundtemplate{
	\setlength{\kitbottom}{\ifbeamer@plainframe1mm\else9mm\fi}%
}

%frametitle
\newlength{\kittitlelength}
\setbeamertemplate{frametitle}{
	\vspace{2mm} %\hspace*{-4mm}
	\pgfmathsetlength{\kittitlelength}{\paperwidth-32mm}
	\vbox{\hsize=\kittitlelength\bfseries\strut\insertframetitle\strut}%
	\ifx\insertframesubtitle\empty%
	\else%
	\vspace{-1.5mm}
	\vbox{\hsize=\kittitlelength\bfseries\strut\normalsize\insertframesubtitle\strut}%
	\fi%
	
	\begin{textblock*}{\paperwidth-12mm}(6mm,5mm)
		\iflanguage{english}{%
			\hfill\includegraphics[height=7mm]{logos/kitlogo_en_rgb} 
		}{%
			\hfill\includegraphics[height=7mm]{logos/kitlogo_de_rgb} 
		}%
	\end{textblock*}
}


\setbeamertemplate{headline}{
}

%footer
%save space in the footer
\beamer@compresstrue
\newlength{\footerlength}


\setbeamertemplate{footline}{
	\begin{beamercolorbox}[%
		leftskip=6mm,%
		rightskip=6mm,%
		ht=0mm,%
		dp=0mm]{section in head/foot}%
		\textcolor{black!50}{\rule{\linewidth-12mm}{0.1mm}}%
	\end{beamercolorbox}%
	\ifthenelse{\boolean{shownavigation}}{%
		%beamer uses some weird hardcoded margins...
		%see beamerbasenavigation.sty \def\insertnavigation
		\begin{beamercolorbox}[
			leftskip=\dimexpr6mm-0.3cm\relax,%
			rightskip=\dimexpr6mm-0.3cm\relax,%
			ht=2.2mm,%
			dp=3mm]{section in head/foot}%
			%include mini frame navigation
			\insertnavigation{\dimexpr\linewidth-0.6cm\relax}%
			\vskip -2.5mm%
		\end{beamercolorbox}%
	}{%
		\vskip 1.0mm%
	}%
	\begin{beamercolorbox}[%
		leftskip=6mm,%
		rightskip=6mm,%
		ht=2.2mm,%
		dp=2mm]{section in head/foot}%
		\usebeamerfont{date in head/foot}%
		\hbox to \dimexpr1ex+7.5mm\relax{\textbf{\insertframenumber{}}}%
		\insertshortdate%
		\hspace{7.5mm}%
		\usebeamerfont{author in head/foot}%
		\insertshortauthor%
		\hspace{2.5pt}--\hspace{2.5pt}%
		\insertshorttitle%
		\hfill%
		\usebeamerfont{date in head/foot}%
		\insertinstitute%
		\vskip -0.5mm%
	\end{beamercolorbox}%
	\ifthenelse{\boolean{shownavigation}}{}{%
		\vskip 0.8mm%
	}%
}

\mode<all>